<template>
  <div>
    <div style="margin: 3rem">
      <el-header style="margin-top:10rem">
        <ReturnButton  :offsetArrow="19" :spanTitle="3" title="Regresar" v-on:clickEvent="returnPage" style="margin:0 0 2rem 12rem"></ReturnButton>
        <el-row :gutter="20" style="margin: 3rem 0">
          <!-- Filtros -->
          <el-col :span="14" :offset="11">
            <el-col :span="9">
              <app-select v-model="filterSelect" :filterArray="allFilters"></app-select>
            </el-col>
            <el-col :span="10">
              <app-search-filter v-model="textSearch"></app-search-filter>
            </el-col>
          </el-col>
        </el-row>
        <!-- titulo -->
        <el-col :offset="2" :span="20" class="bg-dark-gray " style="padding:10px 20px">
          <h3 class="text-white">LISTA DE CONTRATOS: {{this.getProvidersName()}}</h3>
        </el-col>
        <!-- {{ searching[0].admittedMaterials }} -->
      </el-header>
      <el-main style="margin-top:11rem; margin-left:8%; width:84%" v-if="this.materialsReceived.length > 0">
        <el-col v-for="(contract, index) in searching.slice(0,20)" :key="index">
          <app-cards-contracts-provider :principalTitle="'N° DE MATERIALES: '+ contract.refMaterials.length" firstText="Cod. Contrato: " 
                            :valuetext="contract.contractCode" secondMainText="MATERIALES" 
                            :anArray="contract.refMaterials" :isReception="true" :valueTitle="valueTitle" :codMaterial="codMaterial" :color="color" 
                            :isContractsProvider="true"
                            >
          </app-cards-contracts-provider>
        </el-col>   
      </el-main>
      <el-main :offset="2" :span="20" style="margin-top:11rem; margin-right:8%; margin-left:8%; width:84%; min-height: 300px;"  v-else v-loading="loading" :element-loading-text="loadingText">
          <el-row style="margin:1rem 12rem; padding: 3rem; border: 1px solid #a7a4a4; text-aling: right; box-shadow: 3px 3px 7px #a7a4a4; align-items: center;" type="flex" v-show="!loading"> 
            <el-col :span="8" style="text-aling: right" >
              <img src="../../assets/images/icono.svg">
            </el-col>
            <el-col :span="16" style="font-size: 22px; font-weight: 500; color:  hsl(0, 0%, 29%); text-aling: left;">
              <p style="margin-bottom:1rem">¡Lo sentimos!</p>
              <p>Este proveedor no tiene contratos ingresados.</p>
            </el-col>
          </el-row>
      </el-main>
    </div>      
  </div>
</template>
<script>
import SearchFilter from '@/components/searchFilter.vue'
import ReturnButton from '@/components/ReturnButton.vue'
import { modifyText } from '../../utils/modifyText.js'
import Select from '@/components/AppSelect.vue'
// import CardsCanned from '@/components/cardsCanned.vue'
import CardsContractsProvider from '@/components/cardsContractsProvider.vue'
import { HTTP } from '../../main.js'

export default {
  components: {
    ReturnButton,
    'app-search-filter': SearchFilter,
    // 'app-cards-canned': CardsCanned,
    'app-cards-contracts-provider': CardsContractsProvider,
    'app-select': Select,
  },

  data () {
    return {
      filterSelect: '',
      textSearch: '',
      valueTitle: 'listTitle',
      codMaterial: 'idMaterial',
      color:'text-dark',
      allFilters: [
        {value: 'contractCode', label: 'Código contrato'}
        // {value: 'listTitle', label: 'Nombre material'}
      ],
      contractsData: [],
      // contractName: ''
      materialsReceived: [],
      loading: true,
      loadingText: 'Cargando contratos...'
    }
    
  },
  computed:{
    searching () {
      let filterMat = this.contractsData
        filterMat = this.contractsData.filter(
          m => m.confirmedStatus == 'confirmed'
        )

      let contracts = filterMat   
      if( this.textSearch && this.filterSelect == 'contractCode' ) { 
        contracts = filterMat.filter(
          m => modifyText(m[this.filterSelect]).indexOf(modifyText(this.textSearch)) !== -1)
      } 
      // else if (this.filterSelect === 'listTitle' && this.textSearch) {
      //   contracts = filterMat.filter(
      //     m => m.admittedMaterials.map(y => y[this.filterSelect])
      //      .some(x => x.indexOf(modifyText(this.textSearch)) !== -1)
      //   )} 
      else if (this.textSearch) {  
        // let numMaterials = m.admittedMaterials.length   
        // let i   
        contracts = filterMat.filter(
          m =>
          {
            let arr = []
            let materialOfContract = m.admittedMaterials
            materialOfContract.map(el=>{
              let filterMat= modifyText(el.listTitle).indexOf(modifyText(this.textSearch)) > -1
              if(filterMat == true){
                arr.push(el)
              }
            })
            if(arr.length>0){
              return m
            } 
            // modifyText(m.admittedMaterials[0].listTitle).indexOf(modifyText(this.textSearch)) > -1)
        })
            
      }

      //ordenar por geminisCode
      console.log(contracts,'contracts')
      contracts.sort(function(a, b){
        return b.geminisCode - a.geminisCode
      })

      return contracts   
      
    }
  },
  created () {
    this.getContracts()
    
  },
  methods: {
    receivedMat (contract) {
      if (contract){
        // conteo de materiales recibidos
        // let materialsReceived = []
        let array = contract[0].admittedMaterials
        console.log(array,'array')
        array.forEach((mat, index) => {
          this.materialsReceived.push(mat)
          // if (mat.statusMaterial === 3 || mat.statusMaterial === 2){
          //   this.materialsReceived.push(mat)
          // }
        })
        console.log(this.materialsReceived,'materialsReceived')
        return this.materialsReceived.length
      }
    },
    getProvidersName() {
        let providerNameContract = localStorage.getItem('providerNameContract')
        return providerNameContract    
    },
    getProvidersCode() {
        let providerCodeContract = localStorage.getItem('providerCodeContract')   
        return providerCodeContract     
    },
    getContracts () {
        let providerCode = this.getProvidersCode()
       HTTP.get('contracts/providerCode/'+ providerCode)
        .then(res => {
        let contract = this.contractsData = res.data.contracts
        this.receivedMat(res.data.contracts)
        this.loading = false
        console.log(this.receivedMat,'this.receivedMat ()')
        // console.log(res.data.contracts[0].contractHistory[0].refMaterials[0].listTitle,'admittedMaterials')
        console.log(this.getProvidersCode(),'this.getProvidersCode()')
        console.log(contract, 'contract weee')
          
          // this.providerInfo = res.data[0].providers
        })
        .catch(err => {
          console.log(err)
          this.loading = false
        })        

      // let dataType = 'contracts'
      // this.$store.dispatch('getData', dataType)
      // let contract = this.$store.state.contracts

    },
    returnPage () {
      this.$router.push({ name: 'review' })
    },
    clickButton (id, contract) {
      // boton que muestra pendiente, incompleto o completo
      
      let contractId = id
      console.log(contractId)
      // this.$localStorage.set('try', JSON.stringify({
      //   contract: contract,
      //   id: id
      // }))
      this.$localStorage.set('contractIdStorage', id)
      this.$localStorage.set('contract', JSON.stringify(contract))
      this.$router.push('checkReception')
    }
  }
}
</script>
